linux-fedora9-packaging-updates-20080422
[openafs.git] / src / packaging / RedHat / openafs-kmodtool
1 #!/bin/bash
2
3 # kmodtool - Helper script for building kernel module RPMs
4 # Copyright (c) 2003-2007 Ville Skytt√§ <ville.skytta@iki.fi>,
5 #                         Thorsten Leemhuis <fedora@leemhuis.info>
6 #
7 # Modified by Simon Wilkinson for OpenAFS
8
9 # Permission is hereby granted, free of charge, to any person obtaining
10 # a copy of this software and associated documentation files (the
11 # "Software"), to deal in the Software without restriction, including
12 # without limitation the rights to use, copy, modify, merge, publish,
13 # distribute, sublicense, and/or sell copies of the Software, and to
14 # permit persons to whom the Software is furnished to do so, subject to
15 # the following conditions:
16 #
17 # The above copyright notice and this permission notice shall be
18 # included in all copies or substantial portions of the Software.
19 #
20 # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
21 # EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
22 # MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
23 # NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
24 # LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
25 # OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
26 # WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
27
28 shopt -s extglob
29
30 myprog="kmodtool"
31 myver="0.10.13"
32 knownvariants=@(BOOT|PAE?(-debug)|@(big|huge)mem|debug|enterprise|kdump|?(large)smp?(-debug)|uml|xen?([0U])?(-PAE))
33 kmod_name=
34 kver=
35 verrel=
36 variant=
37
38 get_verrel ()
39 {
40   verrel=${1:-$(uname -r)}
41   verrel=${verrel%%$knownvariants}
42 }
43
44 print_verrel ()
45 {
46   get_verrel $@
47   echo "${verrel}"
48 }
49
50 get_variant ()
51 {
52   get_verrel $@
53   variant=${1:-$(uname -r)}
54   variant=${variant##$verrel}
55   variant=${variant:-'""'}
56 }
57
58 print_variant ()
59 {
60   get_variant $@
61   echo "${variant}"
62 }
63
64
65 get_rpmtemplate ()
66 {
67     local variant="${1}"
68     local dashvariant="${variant:+-${variant}}"
69     case "$verrel" in
70         *.EL*) kdep="kernel${dashvariant}-%{_target_cpu} = ${verrel}" ;;
71         *)     kdep="kernel-%{_target_cpu} = ${verrel}${variant}"     ;;
72     esac
73     case "$verrel" in
74         *.fc9*) kname="${verrel}.%{_target_cpu}${variant:+.${variant}}" ;;
75         *)      kname="${verrel}${variant}"                             ;;
76     esac
77
78     cat <<EOF
79 %package       -n kmod-${kmod_name}${dashvariant}
80 Summary:          ${kmod_name} kernel module(s)
81 Group:            System Environment/Kernel
82 Provides:         kernel-modules = ${kname}
83 Provides:         ${kmod_name}-kmod = %{?epoch:%{epoch}:}%{version}-%{release}
84 Provides:         openafs-kernel = %{PACKAGE_VERSION}
85 Requires:         ${kdep}
86 Requires:         ${kmod_name}-kmod-common >= %{?epoch:%{epoch}:}%{version}
87 Requires(post):   /sbin/depmod
88 Requires(postun): /sbin/depmod
89 Release:          %{pkgrel}.%(echo ${verrel} | tr - _)
90 BuildRequires:    kernel${dashvariant}-devel-%{_target_cpu} = ${verrel}
91 %description   -n kmod-${kmod_name}${dashvariant}
92 This package provides the ${kmod_name} kernel modules built for the Linux
93 kernel ${kname} for the %{_target_cpu} family of processors.
94 %post          -n kmod-${kmod_name}${dashvariant}
95 /sbin/depmod -aeF /boot/System.map-${kname} ${kname} > /dev/null || :
96 %postun        -n kmod-${kmod_name}${dashvariant}
97 /sbin/depmod -aF /boot/System.map-${kname} ${kname} &> /dev/null || :
98 %files         -n kmod-${kmod_name}${dashvariant}
99 %defattr(644,root,root,755)
100 /lib/modules/${kname}/extra/${kmod_name}/
101
102 EOF
103 }
104
105 print_rpmtemplate ()
106 {
107   kmod_name="${1}"
108   shift
109   kver="${1}"
110   get_verrel "${1}"
111   shift
112   if [ -z "${kmod_name}" ] ; then
113     echo "Please provide the kmodule-name as first parameter." >&2
114     exit 2
115   elif [ -z "${kver}" ] ; then
116     echo "Please provide the kver as second parameter." >&2
117     exit 2
118   elif [ -z "${verrel}" ] ; then
119     echo "Couldn't find out the verrel." >&2
120     exit 2
121   fi
122
123   for variant in "$@" ; do
124     get_rpmtemplate "${variant}"
125   done
126 }
127
128 usage ()
129 {
130   cat <<EOF
131 You called: ${invocation}
132
133 Usage: ${myprog} <command> <option>+
134  Commands:
135   verrel <uname>                               
136     - Get "base" version-release.
137   variant <uname>                               
138     - Get variant from uname.
139   rpmtemplate <mainpgkname> <uname> <variants> 
140     - Return a template for
141   version  
142     - Output version number and exit.
143 EOF
144 }
145
146 invocation="$(basename ${0}) $@"
147 while [ "${1}" ] ; do
148   case "${1}" in
149     verrel)
150       shift
151       print_verrel $@
152       exit $?
153       ;;
154     variant)
155       shift
156       print_variant $@
157       exit $?
158       ;;
159     rpmtemplate)
160       shift
161       print_rpmtemplate "$@"
162       exit $?
163       ;;
164     version)
165       echo "${myprog} ${myver}"
166       exit 0
167       ;;
168     *)
169       echo "Error: Unknown option '${1}'." >&2
170       usage >&2
171       exit 2
172       ;;
173   esac
174 done
175
176 # Local variables:
177 # mode: sh
178 # sh-indentation: 2
179 # indent-tabs-mode: nil
180 # End:
181 # ex: ts=2 sw=2 et